<?php
	if (!GALLERY_ADMIN_MODE) {
		cpg_die(ERROR, $lang_errors['perm_denied'], __FILE__, __LINE__);
	}
	pageheader('Configure plugin Hide Empty Categories');
	
	global $lang_plugin_php, $CONFIG, $lang_common, $lang_pluginmgr_php, $lang_admin_php, $icon_array;

	list($timestamp, $form_token) = getFormToken();

	// get sanitized POST parameters
		if ($superCage->post->keyExists('submit')) {
		//Check if the form token is valid
		if(!checkFormToken()){
			cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
		}

  // Define the sanitization patterns
  $sanitization_array = array(  
	  'plugin_hide_empty_categories_dbcheck' => array('type' => 'int', 'min' => '0', 'max' => '1')
	  );
  $config_changes_counter = 0;
  foreach ($sanitization_array as $san_key => $san_value) {
          if ($san_value['type'] == 'int') { // type is integer --- start
              if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && $superCage->post->getInt($san_key) != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $superCage->post->getInt($san_key);
                  cpg_db_query("INSERT INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('$san_key', '{$CONFIG[$san_key]}') ON DUPLICATE KEY UPDATE value='{$CONFIG[$san_key]}'");
                  $config_changes_counter++;
              }
          } // type is integer --- end
  }
}	

// Set the option outputs for the form variables
if ($CONFIG['plugin_hide_empty_categories_dbcheck'] == '1') {
	$option_output['plugin_hide_empty_categories_dbcheck'] = 'checked="checked"';
} else { 
	$option_output['plugin_hide_empty_categories_dbcheck'] = '';
}

	// start form
	$superCage = Inspekt::makeSuperCage();
	echo <<< EOT
	<form name="cpgform" id="cpgform" action="{$_SERVER['REQUEST_URI']}" method="post">
EOT;
	
	starttable('100%',  'Configure Plugin Hide Empty Categories', 2, 'cpg_zebra');	
	
	// reply with success to changes or no changes made
	if ($superCage->post->keyExists('submit')) {
    echo <<< EOT
	<tr>
		<td class="tableh2" colspan="2">
EOT;
    if ($config_changes_counter > 0) {
        msg_box('', 'Update Success - Changes Appied', '', '', 'success');
    } else {
        msg_box('', 'No Changes Made', '', '', 'validation');
    }
echo <<< EOT
		</td>
	</tr>
EOT;
}

echo <<< EOT
			<tr>
				<td colspan="2" class="tableh2">
				<b>Configure the only possible option for this plugin</b>
				</td>
			</tr>
			<tr>
				<td class="tableb tableb_alternate " width="40%">
                                Use database check for subcategories?
				</td>
				<td class="tableb tableb_alternate">
				<input type="checkbox" name="plugin_hide_empty_categories_dbcheck" id="plugin_hide_empty_categories_dbcheck" class="checkbox" value="1" {$option_output['plugin_hide_empty_categories_dbcheck']} />
				<label for="plugin_hide_empty_categories_dbcheck" class="clickable_option">{$lang_common['yes']}</label>
				</span>
				</td>
            </tr>
			<tr>
				<td class="tableb tableb_alternate " colspan="2">
                                If enabled, the plugin will use database queries to find out if a category should be displayed because one of its subcategories has pictures.
                                This is useful if those subcategories which have the pictures are so deeply nested that they are not displayed in the layout of the higher-level categories.
                                However, it comes at the cost of needing to do a few additional database queries, so you better enable this only if you need it.
                                <br/>
                                When this option is disabled, decision whether a category should be hidden is only based on the layout information that Coppermine fetches according to the "Number of levels of categories to display" setting (&rarr;Main config in the Album list view section), anyway, and nothing more. I.e. without looking if deeper-nested subcategories would have pictures.
				</td>
            </tr>
			<tr>
				<td colspan="2" class="tableb" align="right">
					<span>
					<input type="hidden" name="form_token" value="{$form_token}" />
					<input type="hidden" name="timestamp" value="{$timestamp}" />
					<input class="admin_menu" type="submit" name="submit" value="Apply" /> 
					</span>
				</td>
			</tr>
		</td>		
EOT;

	endtable();
	echo <<< EOT
	</form>
EOT;

	pagefooter();
	ob_end_flush();

?>
