<?php
/**
 * Coppermine Photo Gallery
 * Coppermine version: 1.5.xx
 *
 * Hide Empty Categories       
 * Version 1.0
 *  
 * Plugin Written by Roland Fulde
 * 31 December 2010
 * last updated: 26 June 2013
 */
if (!defined('IN_COPPERMINE')) { 
	die('Not in Coppermine...');
}


if (!function_exists('theme_display_cat_list')) {

// This is actually a rip-off of the same function from include/themes.inc.php
// and just leaving out one bit from it.
// So this probably means it may conflict with certain themes that customize
// it as well.
function theme_display_cat_list($breadcrumb, &$cat_data, $statistics)
{
    global $template_cat_list, $lang_cat_list;
    if (count($cat_data) > 0) {
        starttable('100%');
        $template = template_extract_block($template_cat_list, 'header');
        $params = array(
                '{CATEGORY}' => $lang_cat_list['category'],
                '{ALBUMS}' => $lang_cat_list['albums'],
                '{PICTURES}' => $lang_cat_list['pictures'],
        );
        echo template_eval($template, $params);
    }

    $template_noalb = template_extract_block($template_cat_list, 'catrow_noalb');
    $template = template_extract_block($template_cat_list, 'catrow');
    foreach($cat_data as $category) {
        if (!isset($category['cat_thumb'])) { $category['cat_thumb'] = ''; }
        if (count($category) == 3) {
// Added here:
            global $CONFIG, $RESTRICTEDWHERE;
            if ($CONFIG['plugin_hide_empty_categories_dbcheck'] == 1) {
                $cid = preg_filter('/.*index\.php\?cat=(\d+).*/', '${1}', $category[0]);
                $allsubcids = array();
                $childcids = array();
                $childcids[] = $cid;
                do {
                    $cidstring = implode(',', $childcids);
                    $result = cpg_db_query("SELECT cid FROM {$CONFIG['TABLE_CATEGORIES']} WHERE parent IN ($cidstring);");
                    $childcids = array();
                    while ($row = mysql_fetch_assoc($result)) {
                        $childcids[] = $row['cid'];
                        $allsubcids[] = $row['cid'];
                    }
                    mysql_free_result($result);
                } while (count($childcids) > 0);
                if (count($allsubcids) > 0) {
                    $allsubcatsstring = implode(',', $allsubcids);
                    $result = cpg_db_query("SELECT COUNT(pid) FROM {$CONFIG['TABLE_PICTURES']} AS r INNER JOIN {$CONFIG['TABLE_ALBUMS']} AS a ON r.aid = a.aid $RESTRICTEDWHERE AND a.category IN ($allsubcatsstring);");
                    list($realpiccount) = mysql_fetch_row($result);
                    mysql_free_result($result);
                    if ($realpiccount > 0) {
// end of addition

            $params = array(
                    '{CAT_TITLE}' => $category[0],
                    '{CAT_THUMB}' => $category['cat_thumb'],
                    '{CAT_DESC}' => $category[1],
            );
            echo template_eval($template_noalb, $params);

// here's just a few "closing" lines again
                    }
                }
            }
// that's all folks
        } elseif (isset($category['cat_albums']) && ($category['cat_albums'] != '')) {
            $params = array(
                    '{CAT_TITLE}' => $category[0],
                    '{CAT_THUMB}' => $category['cat_thumb'],
                    '{CAT_DESC}' => $category[1],
                    '{CAT_ALBUMS}' => $category['cat_albums'],
                    '{ALB_COUNT}' => cpg_float2decimal($category[2]),
                    '{PIC_COUNT}' => cpg_float2decimal($category[3]),
            );
            echo template_eval($template, $params);
        } else {
            $params = array(
                    '{CAT_TITLE}' => $category[0],
                    '{CAT_THUMB}' => $category['cat_thumb'],
                    '{CAT_DESC}' => $category[1],
                    '{CAT_ALBUMS}' => '',
                    '{ALB_COUNT}' => cpg_float2decimal($category[2]),
                    '{PIC_COUNT}' => cpg_float2decimal($category[3]),
            );
            echo template_eval($template, $params);
        }
    }

    if ($statistics && count($cat_data) > 0) {
        $template = template_extract_block($template_cat_list, 'footer');
        $params = array('{STATISTICS}' => $statistics);
        echo template_eval($template, $params);
    }


    if (count($cat_data) > 0)
          endtable();
        echo template_extract_block($template_cat_list, 'spacer');
}
// end of function

}




$thisplugin->add_action('plugin_install','hide_empty_categories_install');
$thisplugin->add_action('plugin_uninstall','hide_empty_categories_uninstall');

// Install the plugin
function hide_empty_categories_install() {
    global $CONFIG, $thisplugin;

    // add new meta to db
    cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (`name`, `value`) VALUES ('plugin_hide_empty_categories_dbcheck', '0')");
    return true;
}                                

// Uninstall the plugin
function hide_empty_categories_uninstall() {
    global $CONFIG, $thisplugin;

    //remove the record from config
    cpg_db_query("DELETE FROM {$CONFIG['TABLE_CONFIG']} WHERE name = 'plugin_hide_empty_categories_dbcheck'");
    return true;
}

?>
